using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using TDCG;
//css_reference Microsoft.DirectX.dll;
//css_reference Microsoft.DirectX.Direct3D.dll;
//css_reference Microsoft.DirectX.Direct3DX.dll;

namespace TDCG.Proportion
{
    public class SexyNJXA2ndMH : IProportion
    {
        Dictionary<string, TPONode> nodes;
        public Dictionary<string, TPONode> Nodes { set { nodes = value; }}

        public void Execute()
        {
            TPONode node;

            node = nodes["W_Hips"];
            node.Scale1(1.5000F, 1.5000F, 1.5000F);
            node.Move(0.0000F, 1.5000F, 0.0000F);

            node = nodes["W_LeftHips_Dummy"];
            node.RotateY(Geometry.DegreeToRadian(-1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-3.0000F));
            node.Move(0.0000F, 0.1000F, 0.1000F);

            node = nodes["W_LeftUpLeg"];
            node.Scale1(1.7700F, 1.2600F, 1.7700F);
            node.RotateX(Geometry.DegreeToRadian(3.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-1.0000F));
            node.Move(0.6600F, 0.0500F, 0.0000F);

            node = nodes["W_LeftUpLegRoll"];
            node.Scale1(1.7000F, 1.7000F, 1.7000F);
            node.RotateY(Geometry.DegreeToRadian(-3.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-0.3000F));
            node.Move(0.0800F, 1.8700F, 0.0600F);

            node = nodes["W_LeftLeg"];
            node.Scale1(1.8700F, 1.2600F, 1.8700F);
            node.RotateX(Geometry.DegreeToRadian(1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(1.9000F));
            node.Move(-0.0800F, 0.0000F, -0.0700F);

            node = nodes["W_LeftLegRoll"];
            node.Scale1(1.3100F, 1.3100F, 1.3100F);
            node.RotateX(Geometry.DegreeToRadian(-2.5000F));
            node.RotateY(Geometry.DegreeToRadian(4.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-2.3000F));
            node.Move(0.0000F, -0.7500F, 0.0000F);

            node = nodes["W_LeftFoot"];
            node.Scale1(0.9900F, 0.9900F, 0.9900F);

            node = nodes["W_LeftToeBase"];
            node.Scale1(0.9900F, 0.9900F, 0.9900F);

            node = nodes["W_RightHips_Dummy"];
            node.RotateY(Geometry.DegreeToRadian(1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(3.0000F));
            node.Move(0.0000F, 0.1000F, 0.1000F);

            node = nodes["W_RightUpLeg"];
            node.Scale1(1.7700F, 1.2600F, 1.7700F);
            node.RotateX(Geometry.DegreeToRadian(3.0000F));
            node.RotateZ(Geometry.DegreeToRadian(1.0000F));
            node.Move(-0.6600F, 0.0500F, 0.0000F);

            node = nodes["W_RightUpLegRoll"];
            node.Scale1(1.7000F, 1.7000F, 1.7000F);
            node.RotateY(Geometry.DegreeToRadian(3.0000F));
            node.RotateZ(Geometry.DegreeToRadian(0.3000F));
            node.Move(-0.0800F, 1.8700F, 0.0600F);

            node = nodes["W_RightLeg"];
            node.Scale1(1.8700F, 1.2600F, 1.8700F);
            node.RotateX(Geometry.DegreeToRadian(1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-1.9000F));
            node.Move(0.0800F, 0.0000F, -0.0700F);

            node = nodes["W_RightLegRoll"];
            node.Scale1(1.3100F, 1.3100F, 1.3100F);
            node.RotateX(Geometry.DegreeToRadian(-2.5000F));
            node.RotateY(Geometry.DegreeToRadian(-4.0000F));
            node.RotateZ(Geometry.DegreeToRadian(2.3000F));
            node.Move(0.0000F, -0.7500F, 0.0000F);

            node = nodes["W_RightFoot"];
            node.Scale1(0.9900F, 0.9900F, 0.9900F);

            node = nodes["W_RightToeBase"];
            node.Scale1(0.9900F, 0.9900F, 0.9900F);

            node = nodes["W_Spine_Dummy"];
            node.Scale1(1.2600F, 1.2600F, 1.2600F);
            node.RotateX(Geometry.DegreeToRadian(-2.0000F));
            node.Move(0.0000F, -0.2100F, 0.1000F);

            node = nodes["W_Spine1"];
            node.Scale1(1.0100F, 1.0100F, 1.0100F);
            node.RotateX(Geometry.DegreeToRadian(-2.0000F));
            node.Move(0.0000F, 0.0000F, 0.0500F);

            node = nodes["W_Spine2"];
            node.Scale1(1.2900F, 1.2900F, 1.2900F);
            node.RotateX(Geometry.DegreeToRadian(-1.0000F));
            node.Move(0.0000F, 0.0300F, -0.0700F);

            node = nodes["W_Spine3"];
            node.Scale1(1.1900F, 1.1900F, 1.1900F);
            node.RotateX(Geometry.DegreeToRadian(-1.0000F));
            node.Move(0.0000F, 0.0300F, -0.0500F);

            node = nodes["W_RightShoulder_Dummy"];
            node.Scale1(1.1600F, 1.1600F, 1.1600F);
            node.Move(-0.1000F, 0.0000F, 0.0000F);

            node = nodes["W_RightShoulder"];
            node.Scale1(1.1300F, 1.1300F, 1.1300F);
            node.Move(0.0300F, 0.0000F, 0.0000F);

            node = nodes["W_RightArm_Dummy"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(0.1200F, 0.0000F, 0.0000F);

            node = nodes["W_RightArm"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(0.0600F, 0.1800F, 0.0000F);

            node = nodes["W_RightArmRoll"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(-0.1600F, 0.0000F, 0.0000F);

            node = nodes["W_RightForeArm"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);

            node = nodes["W_RightForeArmRoll"];
            node.Scale1(0.9000F, 0.9000F, 0.9000F);
            node.Move(-0.9200F, 0.0000F, 0.0000F);

            node = nodes["W_RightHand"];
            node.Scale1(0.9100F, 0.9100F, 0.9100F);

            node = nodes["W_RightHandPinky1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandPinky2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandPinky3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandPinky4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandRing1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandRing2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandRing3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandRing4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandMiddle1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandMiddle2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandMiddle3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandMiddle4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandIndex1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandIndex2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandIndex3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandIndex4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandThumb1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandThumb2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);
            node.Move(-0.1000F, 0.0000F, 0.0000F);

            node = nodes["W_RightHandThumb3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_RightHandThumb4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftShoulder_Dummy"];
            node.Scale1(1.1600F, 1.1600F, 1.1600F);
            node.Move(0.1000F, 0.0000F, 0.0000F);

            node = nodes["W_LeftShoulder"];
            node.Scale1(1.1300F, 1.1300F, 1.1300F);
            node.Move(-0.0300F, 0.0000F, 0.0000F);

            node = nodes["W_LeftArm_Dummy"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(-0.1200F, 0.0000F, 0.0000F);

            node = nodes["W_LeftArm"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(-0.0600F, 0.1800F, 0.0000F);

            node = nodes["W_LeftArmRoll"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);
            node.Move(0.1600F, 0.0000F, 0.0000F);

            node = nodes["W_LeftForeArm"];
            node.Scale1(1.1100F, 1.1100F, 1.1100F);

            node = nodes["W_LeftForeArmRoll"];
            node.Scale1(0.9000F, 0.9000F, 0.9000F);
            node.Move(0.9200F, 0.0000F, 0.0000F);

            node = nodes["W_LeftHand"];
            node.Scale1(0.9100F, 0.9100F, 0.9100F);

            node = nodes["W_LeftHandPinky1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandPinky2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandPinky3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandPinky4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandRing1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandRing2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandRing3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandRing4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandMiddle1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandMiddle2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandMiddle3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandMiddle4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandIndex1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandIndex2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandIndex3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandIndex4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandThumb1"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandThumb2"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);
            node.Move(0.1000F, 0.0000F, 0.0000F);

            node = nodes["W_LeftHandThumb3"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_LeftHandThumb4"];
            node.Scale1(0.8700F, 0.8700F, 0.8700F);

            node = nodes["W_Neck"];
            node.Scale1(1.2800F, 1.2800F, 1.2800F);
            node.Move(0.0000F, -0.1300F, 0.0000F);

            node = nodes["Head"];
            node.Move(0.0000F, -0.1500F, 0.0000F);

            node = nodes["face_oya"];
            node.Scale(0.8000F, 0.8200F, 0.8200F);

            node = nodes["sitakuti_oya"];
            node.Move(0.0000F, 0.0000F, -0.0500F);

            node = nodes["Ha_Down"];
            node.Move(0.0000F, 0.0000F, 0.0500F);

            node = nodes["kutiyoko_r"];
            node.Move(-0.4600F, 0.0000F, 0.0000F);

            node = nodes["kutiyoko_l"];
            node.Move(0.4600F, 0.0000F, 0.0000F);

            node = nodes["uekuti_oya"];
            node.Move(0.0000F, 0.0000F, -0.1000F);

            node = nodes["Ha_UP"];
            node.Move(0.0000F, 0.0000F, 0.1000F);

            node = nodes["eyeline_sita_R"];
            node.Scale(0.6700F, 0.8700F, 0.8200F);
            node.RotateX(Geometry.DegreeToRadian(7.0000F));
            node.Move(0.0000F, 0.0600F, -0.1000F);

            node = nodes["eyeline_sita_L"];
            node.Scale(0.6700F, 0.8700F, 0.8200F);
            node.RotateX(Geometry.DegreeToRadian(7.0000F));
            node.Move(0.0000F, 0.0600F, -0.1000F);

            node = nodes["L_eyeline_oya_L"];
            node.Scale(0.9300F, 0.9300F, 0.7800F);
            node.RotateX(Geometry.DegreeToRadian(-2.0000F));
            node.Move(0.0000F, 0.0600F, -0.0200F);

            node = nodes["R_eyeline_oya_R"];
            node.Scale(0.9300F, 0.9300F, 0.7800F);
            node.RotateX(Geometry.DegreeToRadian(-2.0000F));
            node.Move(0.0000F, 0.0600F, -0.0200F);

            node = nodes["hana_END"];
            node.RotateX(Geometry.DegreeToRadian(-2.0000F));
            node.Move(0.0000F, 0.0800F, 0.0000F);

            node = nodes["mayu_1_R"];
            node.Move(0.0000F, 0.0200F, 0.0000F);

            node = nodes["mayu_1_L"];
            node.Move(0.0000F, 0.0200F, 0.0000F);

            node = nodes["Me_Left"];
            node.Scale(0.8900F, 0.8900F, 0.8900F);
            node.RotateZ(Geometry.DegreeToRadian(16.0000F));
            node.Move(0.0100F, 0.1100F, 0.0400F);

            node = nodes["Me_Right"];
            node.Scale(0.8900F, 0.8900F, 0.8900F);
            node.RotateZ(Geometry.DegreeToRadian(-16.0000F));
            node.Move(-0.0100F, 0.1100F, 0.0400F);

            node = nodes["Kami_Oya"];
            node.Scale(1.0000F, 1.0000F, 1.0300F);
            node.RotateX(Geometry.DegreeToRadian(3.0000F));
            node.Move(0.0000F, -0.0400F, 0.0300F);

            node = nodes["kami_Front_L1"];
            node.Scale(1.0000F, 0.9600F, 1.0000F);
            node.Move(0.0300F, 0.0000F, 0.0000F);

            node = nodes["kami_Front_R1"];
            node.Scale(1.0000F, 0.9600F, 1.0000F);
            node.Move(-0.0300F, 0.0000F, 0.0000F);

            node = nodes["kami_Front_Mid1_L"];
            node.Scale(1.0000F, 0.9000F, 1.0000F);

            node = nodes["kami_Front_Mid2_L"];
            node.Scale(1.0000F, 1.0800F, 1.0000F);

            node = nodes["kami_Front_Mid1_R"];
            node.Scale(1.0000F, 0.9000F, 1.0000F);

            node = nodes["kami_Front_Mid2_R"];
            node.Scale(1.0000F, 1.0800F, 1.0000F);

            node = nodes["Chichi_Right1"];
            node.Scale1(1.2400F, 0.7000F, 1.8000F);
            node.RotateX(Geometry.DegreeToRadian(23.0000F));
            node.RotateY(Geometry.DegreeToRadian(-18.0000F));
            node.RotateZ(Geometry.DegreeToRadian(12.0000F));
            node.Move(0.4700F, -1.0000F, -0.2000F);

            node = nodes["Chichi_Right2"];
            node.Scale1(3.0700F, 3.1600F, 3.6800F);
            node.RotateX(Geometry.DegreeToRadian(4.5000F));
            node.RotateY(Geometry.DegreeToRadian(-1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-1.0000F));
            node.Move(0.1200F, -0.6600F, 0.0600F);

            node = nodes["Chichi_Right3"];
            node.Scale1(3.9000F, 1.7000F, 1.8000F);
            node.RotateX(Geometry.DegreeToRadian(-32.0000F));
            node.Move(0.0000F, 0.7000F, -0.2400F);

            node = nodes["Chichi_Right4"];
            node.Move(0.0000F, 0.0000F, 12.6000F);

            node = nodes["Chichi_Left1"];
            node.Scale1(1.2400F, 0.7000F, 1.8000F);
            node.RotateX(Geometry.DegreeToRadian(23.0000F));
            node.RotateY(Geometry.DegreeToRadian(18.0000F));
            node.RotateZ(Geometry.DegreeToRadian(-12.0000F));
            node.Move(-0.4700F, -1.0000F, -0.2000F);

            node = nodes["Chichi_Left2"];
            node.Scale1(3.0700F, 3.1600F, 3.6800F);
            node.RotateX(Geometry.DegreeToRadian(4.5000F));
            node.RotateY(Geometry.DegreeToRadian(1.0000F));
            node.RotateZ(Geometry.DegreeToRadian(1.0000F));
            node.Move(-0.1200F, -0.6600F, 0.0600F);

            node = nodes["Chichi_Left3"];
            node.Scale1(3.9000F, 1.7000F, 1.8000F);
            node.RotateX(Geometry.DegreeToRadian(-32.0000F));
            node.Move(0.0000F, 0.7000F, -0.2400F);

            node = nodes["Chichi_Left4"];
            node.Move(0.0000F, 0.0000F, 12.6000F);

            node = nodes["skirt_LeftB01"];
            node.Scale(1.2100F, 1.0000F, 1.2100F);

            node = nodes["skirt_RightB01"];
            node.Scale(1.2100F, 1.0000F, 1.2100F);

            node = nodes["skirt_RightS01"];
            node.Scale(1.2100F, 1.0000F, 1.2100F);

            node = nodes["skirt_RightF01"];
            node.Scale(1.0500F, 1.0000F, 1.0500F);

            node = nodes["skirt_LeftF01"];
            node.Scale(1.0500F, 1.0000F, 1.0500F);

            node = nodes["skirt_LeftS01"];
            node.Scale(1.2100F, 1.0000F, 1.2100F);
        }
    }
}
